using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_HideTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(576, 424);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.22";
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.SystemColors.ActiveCaption;
			this.button1.Font = new System.Drawing.Font("Sylfaen", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.ForeColor = System.Drawing.Color.White;
			this.button1.Location = new System.Drawing.Point(440, 456);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(152, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "CollaspeAllGroups";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 486);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private int numberParentRows = 20;
		private int numberChildRows = 10;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID",typeof(int))); //lower case p
			dt.Columns.Add(new DataColumn("ParentName",typeof(int)));
			dt.Columns.Add(new DataColumn("ParentDec",typeof(int)));
			dt.Columns.Add(new DataColumn("check", typeof(string)));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i + 1;//.ToString();
				dr[1] = i%5 + 1;
				dr[2] = (i +1) *12;
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		DataSet ds;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();

			this.gridGroupingControl1.DataSource = parentTable;

			this.gridGroupingControl1.TableControlCellClick +=new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);  

			#region Adding the SummaryCell 

			GridSummaryColumnDescriptor sd1 = new GridSummaryColumnDescriptor("ParentDec",SummaryType.Int32Aggregate ,"ParentDec","{Sum:####}"); 
			GridSummaryColumnDescriptor sd2 = new GridSummaryColumnDescriptor("ParentName",SummaryType.Int32Aggregate ,"ParentName","{Sum:####}"); 
			//For showing two summary row
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add( new GridSummaryRowDescriptor("CaptionSummaryRow", "Summary1", new GridSummaryColumnDescriptor[] {sd1}));
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Borders.All = new GridBorder(GridBorderStyle.Standard);        
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.BackColor = Color.AliceBlue; 

			#endregion

			this.gridGroupingControl1.TopLevelGroupOptions.ShowSummaries = false;
			this.gridGroupingControl1.NestedTableGroupOptions.ShowSummaries = false;

			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("ParentName");    

			this.gridGroupingControl1.ChildGroupOptions.ShowCaptionSummaryCells = true; 
			this.gridGroupingControl1.ChildGroupOptions.CaptionSummaryRow = "CaptionSummaryRow";
			this.gridGroupingControl1.ChildGroupOptions.ShowSummaries = false;

			this.button1.CausesValidation = false; 

			this.gridGroupingControl1.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);



		}

		#region  Get the child record details from the GridCaptionSection/GridCaptionSummaryCell..

		private void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
		{
			  
//			//GridCurrentCell cc = e.TableControl.CurrentCell; 
//
//			//Get the TableCellStyleInfo from GridStyleInfo object
//			GridTableCellStyleInfo style = e.TableControl.Model[e.Inner.RowIndex,e.Inner.ColIndex]   as GridTableCellStyleInfo; 
//
//			if( style != null )
//			{
//				Element eDisplayElement = style.TableCellIdentity.DisplayElement;
//				string s = string.Empty; 
//				string sMsgCaption = string.Empty; 
//				switch( eDisplayElement.Kind)
//				{
//					#region Get Record details.
//					case DisplayElementKind.Record :
//						if( eDisplayElement.ParentTable != null )
//						{
//							if( style.TableCellIdentity.Column != null)
//							{
//								s = "Current Record:" + eDisplayElement.ParentTable.CurrentRecord;
//								s += Environment.NewLine + "Current ColumnName: " + style.TableCellIdentity.Column.Name;
//							}
//						}
//						sMsgCaption = "Record " ;
//						break;
//					#endregion
//
//					#region Get the child record details from the GridCaptionSection/GridCaptionSummaryCell..
//					case DisplayElementKind.Caption:
//						if( eDisplayElement.ParentGroup != null)
//						{
//							// get the CaptionRow from the DisplayElement.
//							GridCaptionRow gr = eDisplayElement as GridCaptionRow;
//							//Accessing the related records in a Group...
//							foreach(Record rec in gr.ParentGroup.Records)
//							{
//								s += Environment.NewLine + "Records:" + rec;
//							}
//
//						}
//						sMsgCaption = "Caption Child Record " ;
//						break;
//					#endregion
//					
//					default :
//						s = "Not a Record and CaptionSection";
//						break;
//				}
//				MessageBox.Show(s,sMsgCaption + "Details"); 
//			}

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.Table.CollapseAllGroups();  
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			Console.WriteLine(e.TableCellIdentity.DisplayElement.Kind  ); 
			if( e.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Caption 
				&& e.Style.CellType == "Static")
			{
				e.Style.CellType = "TextBox";
				e.Style.ReadOnly = false; 
				e.Style.Enabled = true;
				e.Style.Clickable = true;
			}
		}
	}
}
